require "webcomics"
require_relative "version"
require_relative "comics_packager_zip"
require_relative "comics_packager_directory"

ANSI_DEFAULT = "\033[0;0m"
ANSI_RED = "\033[1;31m" # ARGV[0] color
ANSI_GREEN = "\033[1;32m" # ARGV[1] color
ANSI_BLUE = "\033[1;34m"  # ARGV[2] color
ANSI_MAGENTA = "\033[1;35m" # ARGV[3] color
ANSI_CYAN = "\033[1;36m"  # ARGV[4] color

case ARGV[0]
when "version"
  puts "Version: #{ANSI_GREEN}#{ComicsPackager::VERSION}#{ANSI_DEFAULT}"
when "package_cbz"
  if ARGV[1] == "help"
    puts "#{ANSI_CYAN}Useage: comics_packager.rb(or comics_packager.exe on Windows)#{ANSI_DEFAULT} #{ANSI_RED}package_cbz#{ANSI_DEFAULT} #{ANSI_GREEN}[path_to_files_to_zip]#{ANSI_DEFAULT} #{ANSI_BLUE}[input_filenames]#{ANSI_DEFAULT} #{ANSI_MAGENTA}[path_to_output_cbz]#{ANSI_DEFAULT}" 
    puts "#{ANSI_CYAN}Example: comics_packager.rb(or comics_packager.exe on Windows)#{ANSI_DEFAULT} #{ANSI_RED}package_cbz#{ANSI_DEFAULT} #{ANSI_GREEN}'./spec/comics tests/mac_the_comic'#{ANSI_DEFAULT} #{ANSI_BLUE}'Story1/001.jpg Story1/002.jpg'#{ANSI_DEFAULT} #{ANSI_MAGENTA}./mac_the_comic_new#{ANSI_DEFAULT}"
  else
    package_comics_to_cbz(ARGV[1], ARGV[2].split, ARGV[3])
  end
when "list_pages"
  if ARGV[1] == "help"
    puts "#{ANSI_CYAN}Useage: comics_packager.rb(or comics_packager.exe on Windows)#{ANSI_DEFAULT} #{ANSI_RED}list_pages#{ANSI_DEFAULT} #{ANSI_GREEN}[path_to_images]#{ANSI_DEFAULT}" 
    puts "#{ANSI_CYAN}Example: comics_packager.rb(or comics_packager.exe on Windows)#{ANSI_DEFAULT} #{ANSI_RED}list_pages#{ANSI_DEFAULT} #{ANSI_GREEN}'./spec/comics tests/mac_the_comic'#{ANSI_DEFAULT}"
  else
    return_an_array_of_images("cbz", ARGV[1]).each {|images| puts "#{ANSI_GREEN}#{images}#{ANSI_DEFAULT}"}	
  end
when "extract_all"
  if ARGV[1] == "help"
    puts "#{ANSI_CYAN}Useage: comics_packager.rb(or comics_packager.exe on Windows)#{ANSI_DEFAULT} #{ANSI_RED}extract_all#{ANSI_DEFAULT} #{ANSI_GREEN}[source_cbz_file]#{ANSI_DEFAULT} #{ANSI_BLUE}[destination_folder]#{ANSI_DEFAULT}" 
    puts "#{ANSI_CYAN}Example: comics_packager.rb(or comics_packager.exe on Windows)#{ANSI_DEFAULT} #{ANSI_RED}extract_all#{ANSI_DEFAULT} #{ANSI_GREEN}'./spec/comics tests/mac_the_comic'#{ANSI_DEFAULT} #{ANSI_BLUE}./mac_the_comic_new#{ANSI_DEFAULT}"
  else
    extract_entries_from_cbz(ARGV[1], ARGV[2])
  end
=begin
# Will improve this functionlity in a future version.
when "extract"
	if ARGV[1] == "help"
		STDOUT.puts "Useage: comics_packager.rb #{ANSI_RED}extract#{ANSI_DEFAULT} #{ANSI_GREEN}[source_cbz_file]#{ANSI_DEFAULT} #{ANSI_BLUE}[file_to_extract]#{ANSI_DEFAULT} #{ANSI_MAGENTA}[destination_folder]#{ANSI_DEFAULT}" 
		STDOUT.puts "Example: comics_packager.rb #{ANSI_RED}extract#{ANSI_DEFAULT} #{ANSI_GREEN}'./spec/comics tests/mac_the_comic'#{ANSI_DEFAULT} #{ANSI_MAGENTA}./mac_the_comic_new#{ANSI_DEFAULT}"
	else
		Dir.mkdir(ARGV[3])
		extract_file(ARGV[1], ARGV[2], ARGV[4])
	end
=end
when "help"
  puts "#{ANSI_CYAN}Useage: comics_packager.rb(or comics_packager.exe on Windows)#{ANSI_DEFAULT} #{ANSI_RED}[option]#{ANSI_DEFAULT}"
  puts "#{ANSI_GREEN}help#{ANSI_DEFAULT} #{ANSI_CYAN}- Prints help.#{ANSI_DEFAULT}"
  puts "#{ANSI_GREEN}version#{ANSI_DEFAULT} #{ANSI_CYAN}- Prints version number.#{ANSI_DEFAULT}"
  puts "#{ANSI_GREEN}package_cbz#{ANSI_DEFAULT} #{ANSI_CYAN}- Packages comics by taking everything in a specified directory and packaging them into a nice .cbz file for distribution."
  puts "#{ANSI_GREEN}list_pages#{ANSI_DEFAULT} #{ANSI_CYAN}- Prints a list of pages from the .cbz.#{ANSI_DEFAULT}"
  puts "#{ANSI_GREEN}extract_all#{ANSI_DEFAULT} #{ANSI_CYAN}- Extract all entries from a given .cbz.#{ANSI_DEFAULT}"
end

