require "zip"

def extract_entries_from_cbz(source_cbz_file, destination_folder, &block)
  Zip::File.open("#{source_cbz_file}.cbz") do |cbz_file|
    cbz_file.each do |entry|
      entry.extract("#{destination_folder}/#{entry.name}")
        yield entry.name if block_given?
      end
    end
end

def extract_file(source_cbz_file, file_to_extract, destination_folder)
   Zip::File.open("#{source_cbz_file}.cbz") do |cbz|
      cbz.extract(file_to_extract, destination_folder)
    end
end

def package_comics(path_to_files_to_package, input_filenames, path_to_output_package, file_extension_name, &block)
  Zip::File.open("#{path_to_output_package}.#{file_extension_name}", Zip::File::CREATE) do |package|
    input_filenames.each do |filename|
      package.add(filename, path_to_files_to_package + '/' + filename)
      yield filename if block_given?
     end
   end
end

def package_comics_to_cbz(path_to_files_to_zip, input_filenames, path_to_output_cbz)
  package_comics(path_to_files_to_zip, input_filenames, path_to_output_cbz, "cbz")
end

def package_comics_to_zip(path_to_files_to_zip, input_filenames, path_to_output_zip)
  package_comics(path_to_files_to_zip, input_filenames, path_to_output_zip, "zip")
end
